function ButtonTrackingObj(exp, titleName, cm, frame){
   this.VarTrivBtnTracking = new Variable( 'VarTrivBtnTracking', null, 0, cm, frame, exp, titleName, true );
   this.title = null;
}

ButtonTrackingObj.codeToStateMap =
{
	'N' : 'normalState',
	'O' : 'overState',
	'D' : 'downState',
	'A' : 'disabledState',
	'V' : 'visitedState',
	'S' : 'selectedState'
};
ButtonTrackingObj.stateToCodeMap = {};
for (var key in ButtonTrackingObj.codeToStateMap)
	ButtonTrackingObj.stateToCodeMap[ButtonTrackingObj.codeToStateMap[key]] = key;

ButtonTrackingObj.prototype.InitPageTracking = function ( )
{
	var THIS = this;
	var pageTrackData = this.VarTrivBtnTracking.getValue();
	var bDoInit = true;
	try {
	    if (pageTrackData && pageTrackData.length > 0 && pageTrackData != '~~~null~~~')
	    {
	        var topLevelSplit = pageTrackData.split('#');
	        if (topLevelSplit && topLevelSplit.length > 1)
            {
		        var arrIds = topLevelSplit[0].split(',');
		        var arrStatus = topLevelSplit[1].split(',');
		        for( var i=0; i<arrIds.length; i++ )
		        {
			        var id = parseInt( '0x' + arrIds[i] );
			        var status = arrStatus[i];
			        var node = this.FindNode( this.title, id );
			        if( node )
						node.v = ButtonTrackingObj.codeToStateMap[status] || status;
		        }
    		}
        }
    } catch (e) { }
}

ButtonTrackingObj.prototype.FindNode = function( node, id )
{
	if( node.id == id )
		return node;
	
	var match = null;
	if( typeof( node.c ) != 'undefined' ){
		for( var i=0; i<node.c.length; i++ ){
			match = this.FindNode( node.c[i], id );
			if( match != null )
				break;
		}
	}
	
	return match;
}

ButtonTrackingObj.prototype.InternalGetRangeStatus = function( node )
{
	if( node == null )
		return -1;
		
	if( typeof(node.c) == 'undefined' )
	{
		return node.v;
	}
	else
	{
		return 'normalState';
	}
}


ButtonTrackingObj.prototype.GetRangeStatus = function( id, bInit )
{
	var status = -1;
	if ( bInit ) 
		this.InitPageTracking();
	
	status = this.InternalGetRangeStatus( this.FindNode( this.title, id ) );

	return status;
}


ButtonTrackingObj.prototype.InternalSetRangeStatus=function( node, status )
{
	if( node == null )
		return;
	node.v = status;
	if( status == 0 && typeof(node.c)!='undefined')
	{
		for( var i=0; i<node.c.length; i++ )
			this.InternalSetRangeStatus( node.c[i], status ); 
	}
}

ButtonTrackingObj.prototype.SetRangeStatus = function( id, status /*0 or 1 or 2*/)
{
	this.InternalSetRangeStatus( this.FindNode(this.title, id), status );
	
	this.SavePageTracking();
}

ButtonTrackingObj.prototype.IterateTree = function( func )
{
	var stack = [];
	stack.push( this.title );
	var i = 0;
	while( stack.length > 0 )
	{
		var node = stack.shift();
		
		if( typeof(node.c) != 'undefined' )
			stack = node.c.concat(stack);
			
		//do the thing
		func( node, i, stack );
		i++;
	}	
}

ButtonTrackingObj.prototype.SavePageTracking = function()
{
	var fnIsSaveState = window.ObjButton && ObjButton.isSaveState || function () { return false; };
	var hexString = '';
	var arrayIds = [];
	var arrayStatus= [];
	
	this.IterateTree(function(node, i, stack){
		if (fnIsSaveState(node.v))
		{
			arrayIds.push(node.id);
			arrayStatus.push(node.v);
		}
	});
	
	for( var i=0; i<arrayIds.length; i++ )
		hexString += (i > 0 ? ',' : '') + arrayIds[i].toString(16);

	hexString += (arrayIds.length > 0 ? '#' : '');
	
	for (var i = 0; i < arrayStatus.length; i++)
		hexString += (i > 0 ? ',' : '') + (ButtonTrackingObj.stateToCodeMap[arrayStatus[i]] || arrayStatus[i]);

	//LD-8267 - Added a condition to avoid tracking null/empty data unnecessarily
	if (hexString.length > 0 || (myTop.suspendDataCache && myTop.suspendDataCache.indexOf('VarTrivBtnTracking') >= 0) || !this.VarTrivBtnTracking.bSCORM)
		this.VarTrivBtnTracking.set(hexString);
}

var trivBtnTracking = new ButtonTrackingObj(365,'making_money_in_financial_services_citi', 0, 'scorm');
trivBtnTracking.title={id:1,v:0,c:[{id:655155,v:'normalState'},{id:47849,v:'normalState'},{id:50838,v:'normalState'},{id:50845,v:'normalState'},{id:50859,v:'normalState'},{id:265103,v:'normalState'},{id:52029,v:'normalState'},{id:58646,v:'normalState'},{id:598617,v:'normalState'},{id:176645,v:'normalState'},{id:293612,v:'normalState'},{id:575907,v:'normalState'},{id:792169,v:'normalState'},{id:792160,v:'normalState'},{id:827663,v:'normalState'},{id:827683,v:'normalState'},{id:827704,v:'normalState'},{id:827741,v:'normalState'},{id:720758,v:'normalState'},{id:720746,v:'normalState'},{id:720734,v:'normalState'},{id:720722,v:'normalState'},{id:720710,v:'normalState'},{id:720698,v:'normalState'},{id:802069,v:'normalState'},{id:721056,v:'normalState'},{id:836313,v:'normalState'},{id:836322,v:'normalState'},{id:827864,v:'normalState'},{id:827878,v:'normalState'},{id:726220,v:'normalState'},{id:216276,v:'normalState'},{id:221158,v:'normalState'},{id:221271,v:'normalState'},{id:221384,v:'normalState'},{id:728194,v:'normalState'},{id:728744,v:'normalState'},{id:181142,v:'normalState'},{id:739647,v:'normalState'},{id:740176,v:'normalState'},{id:741957,v:'normalState'},{id:580057,v:'normalState'},{id:580049,v:'normalState'},{id:846417,v:'normalState'},{id:846429,v:'normalState'},{id:846441,v:'normalState'},{id:846453,v:'normalState'},{id:846465,v:'normalState'},{id:846477,v:'normalState'},{id:846494,v:'normalState'},{id:846519,v:'normalState'},{id:846539,v:'normalState'},{id:846559,v:'normalState'},{id:846567,v:'normalState'},{id:846576,v:'normalState'},{id:849470,v:'normalState'},{id:849482,v:'normalState'},{id:849494,v:'normalState'},{id:849506,v:'normalState'},{id:849518,v:'normalState'},{id:849530,v:'normalState'},{id:849547,v:'normalState'},{id:849575,v:'normalState'},{id:849598,v:'normalState'},{id:849621,v:'normalState'},{id:849629,v:'normalState'},{id:849638,v:'normalState'},{id:851751,v:'normalState'},{id:851763,v:'normalState'},{id:851775,v:'normalState'},{id:851787,v:'normalState'},{id:851799,v:'normalState'},{id:851811,v:'normalState'},{id:851828,v:'normalState'},{id:851856,v:'normalState'},{id:851879,v:'normalState'},{id:851902,v:'normalState'},{id:851910,v:'normalState'},{id:851919,v:'normalState'},{id:852757,v:'normalState'},{id:852769,v:'normalState'},{id:852781,v:'normalState'},{id:852793,v:'normalState'},{id:852805,v:'normalState'},{id:852817,v:'normalState'},{id:852834,v:'normalState'},{id:852859,v:'normalState'},{id:852879,v:'normalState'},{id:852899,v:'normalState'},{id:852907,v:'normalState'},{id:852916,v:'normalState'},{id:856311,v:'normalState'},{id:856323,v:'normalState'},{id:856335,v:'normalState'},{id:856347,v:'normalState'},{id:856359,v:'normalState'},{id:856371,v:'normalState'},{id:856388,v:'normalState'},{id:856411,v:'normalState'},{id:856429,v:'normalState'},{id:856447,v:'normalState'},{id:856455,v:'normalState'},{id:856464,v:'normalState'},{id:828172,v:'normalState'},{id:828181,v:'normalState'},{id:828190,v:'normalState'},{id:828199,v:'normalState'},{id:828223,v:'normalState'},{id:828237,v:'normalState'},{id:828251,v:'normalState'},{id:828265,v:'normalState'},{id:830309,v:'normalState'},{id:830353,v:'normalState'},{id:867447,v:'normalState'},{id:867456,v:'normalState'},{id:867465,v:'normalState'},{id:724151,v:'normalState'},{id:724139,v:'normalState'},{id:724126,v:'normalState'},{id:687205,v:'normalState'},{id:317325,v:'normalState'},{id:830808,v:'normalState'},{id:830820,v:'normalState'},{id:830832,v:'normalState'},{id:830844,v:'normalState'},{id:873536,v:'normalState'},{id:830861,v:'normalState'},{id:830874,v:'normalState'},{id:830887,v:'normalState'},{id:830900,v:'normalState'},{id:873527,v:'normalState'},{id:831030,v:'normalState'},{id:831044,v:'normalState'},{id:831065,v:'normalState'},{id:831082,v:'normalState'},{id:831114,v:'normalState'},{id:831128,v:'normalState'},{id:831153,v:'normalState'},{id:831174,v:'normalState'},{id:831206,v:'normalState'},{id:831220,v:'normalState'},{id:887078,v:'normalState'},{id:886603,v:'normalState'},{id:831294,v:'normalState'},{id:831308,v:'normalState'},{id:831328,v:'normalState'},{id:887693,v:'normalState'},{id:687477,v:'normalState'},{id:318070,v:'normalState'},{id:831940,v:'normalState'},{id:831952,v:'normalState'},{id:831964,v:'normalState'},{id:831976,v:'normalState'},{id:831993,v:'normalState'},{id:832006,v:'normalState'},{id:832019,v:'normalState'},{id:832032,v:'normalState'},{id:688088,v:'normalState'},{id:832133,v:'normalState'},{id:832177,v:'normalState'},{id:70221,v:'normalState'},{id:322983,v:'normalState'},{id:322975,v:'normalState'},{id:832642,v:'normalState'},{id:832656,v:'normalState'},{id:194542,v:'normalState'},{id:294732,v:'normalState'},{id:321023,v:'normalState'},{id:321015,v:'normalState'},{id:787566,v:'normalState'},{id:787580,v:'normalState'},{id:321952,v:'normalState'},{id:321944,v:'normalState'},{id:323409,v:'normalState'},{id:323401,v:'normalState'},{id:323733,v:'normalState'},{id:323725,v:'normalState'},{id:788049,v:'normalState'},{id:788063,v:'normalState'},{id:832450,v:'normalState'},{id:832313,v:'normalState'},{id:325221,v:'normalState'},{id:325757,v:'normalState'},{id:329044,v:'normalState'},{id:327409,v:'normalState'},{id:920372,v:'normalState'},{id:920381,v:'normalState'},{id:920390,v:'normalState'},{id:920399,v:'normalState'},{id:920435,v:'normalState'},{id:233645,v:'normalState'},{id:233637,v:'normalState'},{id:590305,v:'normalState'},{id:590317,v:'normalState'},{id:673002,v:'normalState'},{id:674262,v:'normalState'},{id:590337,v:'normalState'},{id:590345,v:'normalState'},{id:233060,v:'normalState'},{id:233308,v:'normalState'},{id:135253,v:'normalState'},{id:234172,v:'normalState'},{id:233847,v:'normalState'},{id:233839,v:'normalState'},{id:69966,v:'normalState'}]};
